// deployer BashModule implementation
// Copyright (C) 2024 Jean-Cloud
// GNU General Public License v3

#include <filesystem>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "BashModule.h"
#include "BashManager.h"

using namespace std;

//destructor inline 
BashModule::BashModule()
{
	name="Bash";
}

//private methods
int BashModule::executeScript(string serviceUsername)
{
    //this method is called in deploy(), it executes the script deploy.sh if it exists
    string deployscript="./services/"+serviceUsername+"/deploy.sh";
    if(filesystem::exists(deployscript)){
        pid_t pid = fork(); 
        if (pid == -1) { 
            cerr << "Error when forking." << endl; 
            return -1; 
        } else if (pid > 0) {  
            int status;
            waitpid(-1,&status,0);
            if(status==-1){
                cerr << "Error when executing " << deployscript << endl;
            }
            cout << "status vaut " << status << endl;
            return status;
        } else { 
            if(execl("/bin/bash", "/bin/bash", "--noediting", "--noprofile", "--norc", deployscript.c_str(), (char *)0)==-1)
            {
                cerr << "Error in the execl call of " << deployscript << endl;
            }
        } 
    }
    return 0;
}

//public methods
int BashModule::prepare()
{
    return 0;
}

int BashModule::deploy (string serviceUsername)
{
    cout << "deploy in bash module called" << endl;
    executeScript(serviceUsername);
	return 0;		
}


int BashModule::remove (string serviceUsername)
{
	return 0;
}

int BashModule::clean()
{
	return 0;
} 
